#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <time.h>

#include "ptc/tinyptc.h"
#include "pa/portaudio.h"

#define PI 3.14159265f

#define DWORD unsigned int

#define rnd(n) (rand()%(n+1))

#define KEY_START	0
#define KEY_UP		1
#define KEY_DOWN	2
#define KEY_LEFT	3
#define KEY_RIGHT	4
#define KEY_FIRE	5

bool KeyDown(int key)
{
	switch(key)
	{
	case KEY_START:
		return (GetAsyncKeyState(VK_ESCAPE)&KF_UP);
		break;
	case KEY_UP:
		return (GetAsyncKeyState(VK_UP)&KF_UP);
		break;
	case KEY_DOWN:
		return (GetAsyncKeyState(VK_DOWN)&KF_UP);
		break;
	case KEY_LEFT:
		return (GetAsyncKeyState(VK_LEFT)&KF_UP);
		break;
	case KEY_RIGHT:
		return (GetAsyncKeyState(VK_RIGHT)&KF_UP);
		break;
	case KEY_FIRE:
		return (GetAsyncKeyState('Z')&KF_UP)|(GetAsyncKeyState(VK_RETURN)&KF_UP);
		break;
	}
	return false;
}

#include "game.h"

static DWORD ptc_screen[640*480];

PortAudioStream *stream;

static int AudioCallback(void *inp, void *outp, unsigned long size, PaTimestamp ts, void *data)
{
	float *out=(float*)outp;
	AudioStream(out, size);
	return 0;
}

void main()
{
	srand(time(NULL));

	if(!ptc_open("cwd07", 640, 480))
		return;

	SetEnvironmentVariable("PA_MIN_LATENCY_MSEC", "75");
	Pa_Initialize();
	Pa_OpenDefaultStream(&stream, 0, 1, paFloat32, 44100, 512, 0, AudioCallback, NULL);
	Pa_StartStream(stream);

	ResetGame();

	DWORD mst=timeGetTime();
	for(;;)
	{
		if(!GameTick())
			break;
		DrawScreen(ptc_screen);
		ptc_update(ptc_screen);
		while(timeGetTime()<mst+16)
			Sleep(0);
		mst=timeGetTime();
	}

    Pa_StopStream(stream);
    Pa_CloseStream(stream);
    Pa_Terminate();

	ptc_close();
	ExitProcess(0);
}

